package com.mrbool.jackson;

import java.io.File;
import java.io.IOException;
import java.util.Date;

import com.fasterxml.jackson.core.JsonGenerationException;
import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;

public class JavaJsonTests {

	private ObjectMapper objectMapper = new ObjectMapper();
	
	public static void main(String[] args) {
		new JavaJsonTests().jsonToJava();
	}
	
	private void javaToJson() {
		Person person = mockPerson();
		
		try {
			objectMapper.writerWithDefaultPrettyPrinter().writeValue(new File("F://temp//person.json"), person);
			String json = objectMapper.writerWithDefaultPrettyPrinter().writeValueAsString(person);
			System.out.println(json);
		} catch (JsonGenerationException e) {
			e.printStackTrace();
		} catch (JsonMappingException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private void jsonToJava() {
		try {
			Person person = objectMapper.readValue(new File("F://temp//person.json"), Person.class);
			Person person2 = objectMapper.readValue("{\"id\": \"2\"}", Person.class);
			System.out.println(person);
			System.out.println(person2);
			
		} catch (JsonParseException e) {
			e.printStackTrace();
		} catch (JsonMappingException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private Person mockPerson() {
		Person person = new Person();
		person.setId(1);
		person.setName("MrBool");
		person.setSalary(2000.00);
		person.setBirth(new Date());
		
		return person;
	}
	
}
